glibmm: Gio::ThemedIcon Class Reference

glibmm 2.41.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::ThemedIcon Class Reference

Icon theming support ThemedIcon is an implementation of Gio::Icon that supports icon themes. More...

`#include <giomm/themedicon.h>`

Inheritance diagram for Gio::ThemedIcon:
[legend]

## Public Member Functions
virtual | ~ThemedIcon ()
GThemedIcon* | gobj ()
| Provides access to the underlying C GObject. More...
const GThemedIcon* | gobj () const
| Provides access to the underlying C GObject. More...
GThemedIcon* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | prepend_name (const std::string& iconname)
| Prepend a name to the list of icons from within icon. More...
void | append_name (const std::string& iconname)
| Append a name to the list of icons from within icon. More...
Glib::StringArrayHandle | get_names () const
| Gets the names of icons from within icon. More...
Glib::PropertyProxy_ReadOnly < std::vector< Glib::ustring > > | property_names () const
| An array containing the icon names. More...
Glib::PropertyProxy_ReadOnly < bool > | property_use_default_fallbacks () const
| Whether to use default fallbacks found by shortening the name at '-' characters. More...
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from Gio::Icon
virtual | ~Icon ()
GIcon* | gobj ()
| Provides access to the underlying C GObject. More...
const GIcon* | gobj () const
| Provides access to the underlying C GObject. More...
guint | hash () const
| Gets a hash for an icon. More...
std::string | to_string () const
| Generates a textual representation of icon that can be used for serialization such as when passing icon to a different process or saving it to persistent storage. More...
bool | equal (const Glib::RefPtr< Icon >& other) const
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< ThemedIcon > | create (const std::string& iconname, bool use_default_callbacks=false)
| Creates a new themed icon for @ iconname, and optionally all the names that can be created by shortening iconname at '-' characters. More...
Static Public Member Functions inherited from Gio::Icon
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Icon > | create (const std::string& str)

## Protected Member Functions
| ThemedIcon (const std::string& iconname, bool use_default_callbacks=false)
| Creates a new themed icon for @ iconname, and optionally all the names that can be created by shortening iconname at '-' characters. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)
Protected Member Functions inherited from Gio::Icon
| Icon ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::ThemedIcon > | wrap (GThemedIcon* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::Icon
Glib::RefPtr< Gio::Icon > | wrap (GIcon* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

Icon theming support ThemedIcon is an implementation of Gio::Icon that supports icon themes.

ThemedIcon contains a list of all of the icons present in an icon theme, so that icons can be looked up quickly. ThemedIcon does not provide actual pixmaps for icons, just the icon names. Ideally something like Gtk::IconTheme::choose_icon() should be used to resolve the list of names so that fallback icons work nicely with themes that inherit other themes.

Since glibmm 2.16:

## Constructor & Destructor Documentation

virtual Gio::ThemedIcon::~ThemedIcon | ( |  | ) |
| virtual

Gio::ThemedIcon::ThemedIcon | ( | const std::string & | iconname,
|  | bool | use_default_callbacks = `false`
| ) |  |
| explicitprotected

Creates a new themed icon for @ iconname, and optionally all the names that can be created by shortening iconname at '-' characters.

Parameters

  iconname | A string containing an icon name.
  use_default_callbacks | Whether to use all the names that can be created by shortening iconname at '-' characters.

## Member Function Documentation

void Gio::ThemedIcon::append_name | ( | const std::string & | iconname | ) |

Append a name to the list of icons from within icon.

Note that doing so invalidates the hash computed by prior calls to g_icon_hash().

Parameters

  iconname | Name of icon to append to list of icons from within icon.

static Glib::RefPtr<ThemedIcon> Gio::ThemedIcon::create | ( | const std::string & | iconname,
|  | bool | use_default_callbacks = `false`
| ) |  |
| static

Creates a new themed icon for @ iconname, and optionally all the names that can be created by shortening iconname at '-' characters.

Parameters

  iconname | A string containing an icon name.
  use_default_callbacks | Whether to use all the names that can be created by shortening iconname at '-' characters.

Glib::StringArrayHandle Gio::ThemedIcon::get_names | ( |  | ) | const

Gets the names of icons from within icon.

Returns
  A list of icon names.

static GType Gio::ThemedIcon::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GThemedIcon* Gio::ThemedIcon::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GThemedIcon* Gio::ThemedIcon::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GThemedIcon* Gio::ThemedIcon::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gio::ThemedIcon::prepend_name | ( | const std::string & | iconname | ) |

Prepend a name to the list of icons from within icon.

Note that doing so invalidates the hash computed by prior calls to g_icon_hash().

Since glibmm 2.18:
  Parameters

    iconname | Name of icon to prepend to list of icons from within icon.

Glib::PropertyProxy_ReadOnly< std::vector<Glib::ustring> > Gio::ThemedIcon::property_names | ( |  | ) | const

An array containing the icon names.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gio::ThemedIcon::property_use_default_fallbacks | ( |  | ) | const

Whether to use default fallbacks found by shortening the name at '-' characters.

Ignores names after the first if multiple names are given.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::ThemedIcon > wrap | ( | GThemedIcon * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.